#!/usr/bin/perl
while (<STDIN>) {
    next if /^%/;
    s/([^\\])%.*/\1/;
    while (/\\cite{([^}]+)}/) {
	$_ = $';
	for (split(",",$1)) {
	    if (!defined($ref{$_})) { $ref{$_} = ++$refs; }
	}
    }
}
$refs =~ /^(\d)(\d+)*$/;
print "\\begin{thebibliography}{$1".("8" x length($2))."}\n" ||
  die "write: $!";
if ($ENV{"BIBPATH"}) {
    for (split(":",$ENV{"BIBPATH"})) {
	if (-f $_) { push(@bibpath,$_); }
	else { push(@bibpath,$_ =~ m|/$| ? $_ : $_."/"); }
    }
}
else {
    @root = stat("/");
    for ($path = ""; 1; $path .= "../") {
	@curr = stat($path.".");
	last if $root[0] == $curr[0] && $root[1] == $curr[1];
	push(@bibpath,$path);
    }
}
for (@bibpath) {
    open(FILE,$_ =~ m|/$| ? $_."BIBLIOGRAPHY" : $_) || next;
    while (<FILE>) {
	next if /^%/;
	next if /^\s*$/;
	if (/\\bibitem{([^}]+)}/) {
	    $copy = $ref{$1};
	    delete $ref{$1};
	}
	if ($copy) { $ref[$copy] .= $_; }
    }
    close FILE;
}
for (@ref) { print || die "write: $!"; }
print "\\end{thebibliography}\n" || die "write: $!";
for (sort keys %ref) { print STDERR "Missing reference: $_\n"; }
